import pino from "pino"
import { LOG_LEVEL } from "@/config.ts"

/**
 * / Returns a logging instance with the default log-level "info"
 */
const logger = pino(
  pino.destination({
    level: LOG_LEVEL,
  }),
)

console.log = function (...args): void {
  if (args.length > 1) {
    logger.info(args?.slice(1), args?.[0])
  } else {
    logger.info(args?.[0])
  }
}

export default logger
