import type { Dayjs } from "dayjs"

export type TokenResponse = {
  key: TokenKey
  token: string
  expires_at: Dayjs
}

export type TokenResponseRaw = {
  [K in keyof TokenResponse]: K extends "expires_at" ? string : TokenResponse[K]
}

export type TokenKey = "access-token" | "refresh-token"
